package CustomerOrder;

use strict;
use vars qw(@ISA);
use CGI::XMLApplication;
use XML::LibXML::SAX::Builder;
use XML::Generator::DBI;
use DBI;

@ISA = qw(CGI::XMLApplication);

# event callbacks
sub registerEvents { 
    qw( order_confirm order_send ); 
}

sub event_init {
    my ($self, $context) = @_;
    $context->{DOMTREE} = $self->fetch_recordset();
}

sub event_default {
    my ($self, $context) = @_;
    $context->{SCREENSTYLE} = 'order_default.xsl';
}

sub event_order_confirm {
    my ($self, $context) = @_;
    $context->{SCREENSTYLE} = 'order_confirm.xsl';
}

sub event_order_send {
    my ($self, $context) = @_;
    $context->{SCREENSTYLE} = 'order_send.xsl';
}

# app config and helpers
sub selectStylesheet {
    my ($self, $context) = @_;
    my $style = $context->{SCREENSTYLE} || 'default';
    my $style_path = '/opt/www/htdocs/stylesheets/cart/';
    return $style_path . $style;
}
 
sub requestDOM {
    my ($self, $context) = @_;
    my $root = $context->{DOMTREE}->getDocumentElement();
    my $grand_total = '0';
	
    foreach my $row ($root->findnodes('/document/productlist/product')) {
        my $id         = $row->findvalue('id');
        my $cost       = $row->findvalue('price');
        my $quantity   = $context->{PARAMS}->{$id} || '0';
        my $item_total = $quantity * $cost;
        $grand_total  += $item_total;
        
        # add the order quantity and item totals to the tree.
        $row->appendTextChild('quantity', $quantity);
        $row->appendTextChild('item-total', $item_total);
    }
    my $info = XML::LibXML::Element->new('instance-info');
    $info->appendTextChild('order-total', $grand_total);
    $root->appendChild($info);
    warn $context->{DOMTREE}->toString();
    return $context->{DOMTREE};
}

sub fetch_recordset {
    my $self = shift;
    my $sql = 'select id, name, price from products';

    my $dbh = DBI->connect('dbi:Oracle:webclients', 
                           'chico', 
                           'swordfish')
      || die "database connection couldn't 
              be initialized: $DBI::errstr \n";

    my $builder = XML::LibXML::SAX::Builder->new();
    my $gen = XML::Generator::DBI->new(Handler      => $builder, 
                                       dbh          => $dbh,
                                       RootElement  => 'document', 
                                       QueryElement => 'productlist', 
                                       RowElement   => 'product');

    warn "SQL $sql \n";
    my $dom = $gen->execute($sql) || die "Error Building DOM Tree\n";
    return $dom;
}
   
        

1;
