<?xml version="1.0"?>
<xsl:stylesheet 
     xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
     version="1.0">
<xsl:template match="/">
  <html>
  <head><title>Thank You</title></head>
  <body>
    <xsl:apply-templates />
  </body>
  </html>
</xsl:template>

<xsl:template match="document">
      <xsl:apply-templates select="productlist"/>
</xsl:template>

<xsl:template match="productlist">
  <table border="0">
    <tr><th>ID</th><th>Name</th><th>Price</th><th>Quantity</th><th>Item Total</th></tr>
      <xsl:apply-templates/>
    <tr>
      <td colspan="5" align="right">
        Total Cost: <xsl:value-of select="/document/instance-info/order-total"/>
      </td>
    </tr>
    <tr>
     <td colspan="5" align="center">
       Your order has been sent. Thank you for shopping S-Mart! 
     </td>
   </tr>
  </table>
</xsl:template>

<xsl:template match="product[quantity > 0]">
  <tr>
      <xsl:apply-templates/>
  </tr>
</xsl:template>

<xsl:template match="product[quantity = 0]">
  <!-- this space intentionally blank -->
</xsl:template>

<xsl:template match="ID|NAME|price">
  <td>
    <xsl:value-of select="."/>
  </td>
</xsl:template>

<xsl:template match="item-total">
  <td align="right">
    <xsl:value-of select="."/>
  </td>
</xsl:template>

<xsl:template match="quantity">
  <td>
    <input type="hidden"
           name="{preceding-sibling::ID}"
           value="{.}"/>
  <xsl:value-of select="."/>
  </td>
</xsl:template>


</xsl:stylesheet>
